#ifndef __ATOMIC_INT_OPS_H__
#define __ATOMIC_INT_OPS_H__

#include "nxp_config.h"

#ifdef I386_ASSEM

# define NXP_ATOMIC_INT_INC(x)  asm( "incl %0" : "=m"(x) : "m"(x) )
# define NXP_ATOMIC_INT_DEC(x)  asm( "decl %0" : "=m"(x) : "m"(x) )

#else

/* Not really atomic, but it's the best gcc can do */
# define NXP_ATOMIC_INT_INC(x) (++(x))
# define NXP_ATOMIC_INT_DEC(x) (--(x))

#endif

#endif
