/* -*- Mode: C; c-file-style: "bsd"; -*- */

#ifndef __NXP_COMPLEX_H__
#define __NXP_COMPLEX_H__

#include <complex.h>

typedef __complex__ long double 	nxp_complex_t; /* NumeXP complexes */

#define CXREAL(z) (__real__(z))	/* get real part from complex */
#define CXIMAG(z) (__imag__(z))	/* get imaginary part from complex */
#define CXCONJ(z) (~(z))	/* get conjugate of complex */

typedef struct _NxpElementComplex 	NxpElementComplex;

#include "element.h"

#define NXP_ELEMENT_COMPLEX(x)	(NXP_ELEMENT_TYPECAST(x, NXP_ELEMENT_TYPE_COMPLEX,	NxpElementComplex	))
#define NXP_ELEMENT_IS_COMPLEX(x)	        (NXP_ELEMENT_GET_TYPE(x) == NXP_ELEMENT_TYPE_COMPLEX)

struct _NxpElementComplex {
    NxpElement element;
    nxp_complex_t value;
};


NxpElement* nxp_element_complex_new          (nxp_complex_t     value);
void        nxp_element_complex_init         (GError          **error);

#endif /* __NXP_COMPLEX_H__ */
