/* -*- Mode: C; c-file-style: "bsd"; -*- */
#ifndef __NXP_TYPES_H__
#define __NXP_TYPES_H__

#include "real.h"
#include "nxp_complex.h"
#include "tree.h"
#include "int.h"
#include "matrix.h"
#include "vector.h"
#include "function.h"
#include "nxp_string.h"
#include "variable.h"
#include "void.h"


void nxp_types_init(GError **error);

// Initializers for relations
void nxp_element_frac_int_init		(GError **error);
void nxp_element_real_int_init          (GError **error);

void nxp_element_complex_int_init       (GError **error);
void nxp_element_complex_real_init      (GError **error);

void nxp_element_vector_int_init        (GError **error);
void nxp_element_vector_real_init       (GError **error);
void nxp_element_vector_complex_init    (GError **error);
void nxp_element_vector_any_init	(GError **error);

void nxp_element_matrix_int_init        (GError **error);
void nxp_element_matrix_real_init       (GError **error);
void nxp_element_matrix_complex_init    (GError **error);
void nxp_element_matrix_vector_init     (GError **error);
void nxp_element_matrix_any_init	(GError **error);

void nxp_element_string_int_init        (GError **error);
void nxp_element_string_real_init       (GError **error);
void nxp_element_string_complex_init    (GError **error);
void nxp_element_string_vector_init     (GError **error);
void nxp_element_string_matrix_init     (GError **error);

void nxp_element_variable_int_init      (GError **error);
void nxp_element_variable_real_init     (GError **error);
void nxp_element_variable_complex_init  (GError **error);
void nxp_element_variable_vector_init   (GError **error);
void nxp_element_variable_matrix_init   (GError **error);
void nxp_element_variable_string_init   (GError **error);


#endif /* __NXP_TYPES_H__ */
